<%- include('../partials/header') %>
<link rel="stylesheet" href="/css/signin.css">
<%- include('../partials/file-start') %>

<form class="form-signin flex-grow-1 mt-5 pt-5" id="register">
    <img src="/images/fire.svg" alt="Logo výsledků" width="100">
    <h1 class="h3 mb-3 mt-0 font-weight-normal">Registrace</h1>

    <label for="firstname" class="sr-only">Křestní jméno</label>
    <input type="text" id="firstname" class="form-control mb-2" placeholder="Křestní jméno" autofocus>

    <label for="lastname" class="sr-only">Příjmení</label>
    <input type="text" id="lastname" class="form-control mb-2" placeholder="Příjmení">

    <label for="email" class="sr-only">Emailová adresa</label>
    <input type="email" id="email" class="form-control mb-2" placeholder="Emailová adresa" required>

    <label for="password" class="sr-only">Heslo</label>
    <input type="password" id="password" class="form-control mb-2" placeholder="Heslo" required>

    <label for="password-again" class="sr-only">Heslo znova</label>
    <input type="password" id="password-again" class="form-control" placeholder="Heslo znova"
        required>

    <div class="form-group" id="register-status" style="display: none;"></div>

    <button class="btn btn-lg btn-dark btn-block" type="submit" id="submit">Registrovat</button>
    <a href="/login" class="btn btn-lg btn-secondary btn-block text-white">Přihlášení</a>
</form>

<script>
    $(document).ready(function () {
        $('form#register').submit(function (event) {
            event.preventDefault()
            if ($('#password').val() !== $('#password-again').val()) {
                $('div#register-status')
                    .empty()
                    .append(
                        $('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
                            $('<i>', { class: 'fas fa-exclamation-triangle', 'aria-hidden': 'true' }),
                            $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                            ' Hesla se musí shodovat!'
                        )
                    )
                    .show()
            } else {
                $('div#register-status')
                    .empty()
                    .append(
                        $('<div>', { class: 'alert alert-info alert-dismissible' }).append(
                            $('<i>', { class: 'fas fa-circle-notch fa-spin' }),
                            $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                            ' Vytvářím účet'
                        )
                    )
                    .show()
                let email = $('#email').val()
                let password = $('#password').val()
                let firstname = $('#firstname').val()
                let lastname = $('#lastname').val()
                let middlename = $('#middlename').val()
                let strongAlertText = 'Ach ne'
                let alertText
                let alertStatus

                if (email === '') {
                    alertText = 'Email nemůže být prázdný'
                } else if (password === '') {
                    alertText = 'Heslo nemůže být prázdné'
                } else if (!email.includes('@')) {
                    alertText = 'Zadaný email je neplatný'
                }

                if (alertText !== undefined) {
                    $('div#register-status')
                        .empty()
                        .append(
                            $('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
                                $('<i>', { class: 'fas fa-exclamation-triangle', 'aria-hidden': 'true' }),
                                $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                                $('<strong>').text(strongAlertText),
                                ` ${alertText}`
                            )
                        )
                        .show()
                }

                API.user.new(email, password, firstname, lastname, middlename).done(function (responseFromServer) {
                    if (responseFromServer === 'ok') {
                        $('div#register-status')
                            .empty()
                            .append(
                                $('<div>', { class: 'alert alert-success alert-dismissible' }).append(
                                    $('<i>', { class: 'fas fa-check' }),
                                    $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                                    $('<strong>').text('Gratuluji!'),
                                    ' Úspěšně jste se zaregistroval(a)'
                                )
                            )
                            .show()

                        // Redirect to login page
                        setTimeout(function () {
                            window.location.href = '/login';
                        }, 3500)
                    } else if (responseFromServer === 'email-exist') {
                        $('div#register-status')
                            .empty()
                            .append(
                                $('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
                                    $('<i>', { class: 'fas fa-exclamation-triangle', 'aria-hidden': 'true' }),
                                    $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                                    $('<strong>').text('Ach ne!'),
                                    ' Uživatel s tímto emailem již existuje'
                                )
                            )
                            .show()
                    } else if (responseFromServer === 'err-sending-email') {
                        $('div#register-status')
                            .empty()
                            .append(
                                $('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
                                    $('<i>', { class: 'fas fa-exclamation-triangle', 'aria-hidden': 'true' }),
                                    $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                                    $('<strong>').text('Ach ne!'),
                                    ' Bohužel se nepodařilo Vám odeslat email, ale účet byl vytvořen'
                                )
                            )
                            .show()
                    } else {
                        $('div#register-status')
                            .empty()
                            .append(
                                $('<div>', { class: 'alert alert-danger alert-dismissible' }).append(
                                    $('<i>', { class: 'fas fa-exclamation-triangle', 'aria-hidden': 'true' }),
                                    $('<a>', { href: '#', class: 'close', 'data-dismiss': 'alert', 'aria-label': 'close' }).html('&times;'),
                                    $('<strong>').text('Ach ne!'),
                                    ' Stala se obecná chyba, o které může vědět jen administrátor'
                                )
                            )
                            .show()
                    }
                })
            }
        })
    })
</script>
<%- include('../partials/footer') %>
<%- include('../partials/file-end') %>